<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_VisaElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_VisaElement extends AbstractStructArrayBase
{
    /**
     * The VisaElement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_VisaElement[]
     */
    public $VisaElement;
    /**
     * Constructor method for ArrayOfJP_VisaElement
     * @uses ArrayOfJP_VisaElement::setVisaElement()
     * @param \StructType\JP_VisaElement[] $visaElement
     */
    public function __construct(array $visaElement = array())
    {
        $this
            ->setVisaElement($visaElement);
    }
    /**
     * Get VisaElement value
     * @return \StructType\JP_VisaElement[]|null
     */
    public function getVisaElement()
    {
        return $this->VisaElement;
    }
    /**
     * This method is responsible for validating the values passed to the setVisaElement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVisaElement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVisaElementForArrayConstraintsFromSetVisaElement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_VisaElementVisaElementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_VisaElementVisaElementItem instanceof \StructType\JP_VisaElement) {
                $invalidValues[] = is_object($arrayOfJP_VisaElementVisaElementItem) ? get_class($arrayOfJP_VisaElementVisaElementItem) : sprintf('%s(%s)', gettype($arrayOfJP_VisaElementVisaElementItem), var_export($arrayOfJP_VisaElementVisaElementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VisaElement property can only contain items of type \StructType\JP_VisaElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VisaElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_VisaElement[] $visaElement
     * @return \ArrayType\ArrayOfJP_VisaElement
     */
    public function setVisaElement(array $visaElement = array())
    {
        // validation for constraint: array
        if ('' !== ($visaElementArrayErrorMessage = self::validateVisaElementForArrayConstraintsFromSetVisaElement($visaElement))) {
            throw new \InvalidArgumentException($visaElementArrayErrorMessage, __LINE__);
        }
        $this->VisaElement = $visaElement;
        return $this;
    }
    /**
     * Add item to VisaElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_VisaElement $item
     * @return \ArrayType\ArrayOfJP_VisaElement
     */
    public function addToVisaElement(\StructType\JP_VisaElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_VisaElement) {
            throw new \InvalidArgumentException(sprintf('The VisaElement property can only contain items of type \StructType\JP_VisaElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VisaElement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_VisaElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_VisaElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_VisaElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_VisaElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_VisaElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VisaElement
     */
    public function getAttributeName()
    {
        return 'VisaElement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_VisaElement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
